using System;
using System.IO;
using System.Threading.Tasks;
using DysonNetwork.Common.Models;

namespace DysonNetwork.Common.Interfaces
{
    public interface IFileServiceClient
    {
        Task<CloudFile> GetFileAsync(string fileId);
        Task<Stream> GetFileStreamAsync(string fileId);
        Task<CloudFile> UploadFileAsync(Stream fileStream, string fileName, string? contentType = null);
        Task DeleteFileAsync(string fileId);
        Task<CloudFile> ProcessImageAsync(Stream imageStream, string fileName, string? contentType = null);
        Task<string> GetFileUrl(string fileId, bool useCdn = false);
    }
}
