using System.Globalization;
using DysonNetwork.Common.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Localization;
using NodaTime;

namespace DysonNetwork.Pass.Features.Account.Interfaces;

public interface IAccountEventService
{
    void PurgeStatusCache(Guid userId);
    Task<Status> GetStatus(Guid userId);
    Task<Dictionary<Guid, Status>> GetStatuses(List<Guid> userIds);
    Task<Status> CreateStatus(Models.Account user, Status status);
    Task ClearStatus(Models.Account user, Status status);
    Task<bool> CheckInDailyDoAskCaptcha(Models.Account user);
    Task<bool> CheckInDailyIsAvailable(Models.Account user);
    Task<CheckInResult> CheckInDaily(Models.Account user);
    Task<List<DailyEventResponse>> GetEventCalendar(Models.Account user, int month, int year = 0, bool replaceInvisible = false);
}
