using DysonNetwork.Common.Models;
using NodaTime;

namespace DysonNetwork.Pass.Features.Auth.Interfaces;

public interface IAuthService
{
    Task<int> DetectChallengeRisk(HttpRequest request, Common.Models.Account account);
    Task<AuthSession> CreateSessionForOidcAsync(Common.Models.Account account, Instant time, Guid? customAppId = null);
    Task<bool> ValidateCaptcha(string token);
    string CreateToken(AuthSession session);
    Task<bool> ValidateSudoMode(AuthSession session, string? pinCode);
    Task<bool> ValidatePinCode(Guid accountId, string pinCode);
    bool ValidateToken(string token, out Guid sessionId);
}
