using System;
using System.Collections.Generic;
using DysonNetwork.Common.Models;
using NodaTime;

namespace DysonNetwork.Sphere.Activity;

public class DiscoveryActivity(List<DiscoveryItem> items) : IActivity
{
    public List<DiscoveryItem> Items { get; set; } = items;

    public Common.Models.Activity ToActivity()
    {
        var now = SystemClock.Instance.GetCurrentInstant();
        return new Common.Models.Activity
        {
            Id = Guid.NewGuid(),
            Type = "discovery",
            ResourceIdentifier = "discovery",
            Data = this,
            CreatedAt = now,
            UpdatedAt = now,
        };
    }
}

public record DiscoveryItem(string Type, object Data);